=== debian/changelog ===
openmprtl (0.20131209-1) unstable; urgency=low

  * New upstrem release
  * Standards-Version updated to 3.9.5
  * Update libiomp5.symbols. Introduction of @OMP_1.0 & @OMP_3.0

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 19 Jan 2014 16:40:56 +0100

openmprtl (0.20130912-1) unstable; urgency=low

  * New upstream release
  * README => README.txt
  * Two new symbols added kmpc_omp_task_with_deps & kmpc_omp_wait_deps

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 30 Sep 2013 16:53:17 +0200

openmprtl (0.20130715-1) unstable; urgency=low

  * Initial release (Closes: #706599)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 30 May 2013 11:38:31 +0200
