=== debian/control ===
Source: openmprtl
Priority: extra
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 8.0.0), doxygen, gfortran
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.openmprtl.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/llvm-toolchain/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/llvm-toolchain/trunk/

Package: libiomp-dev
Section: libdevel
Architecture: any
Depends: libiomp5 (= ${binary:Version}), ${misc:Depends}
Description: Intel OpenMP runtime - dev package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.

Package: libiomp5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel OpenMP runtime
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.

Package: libiomp5-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libiomp5 (= ${binary:Version})
Description: Intel OpenMP runtime - Debug package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package contains the library with the debug symbols.

Package: libiomp-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
Description: Intel OpenMP runtime - Documentation
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package contains the documentation of this package.
