=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
SONAME=5

%:
	dh $@

override_dh_auto_build:
	make compiler=gcc
	cd tmp/lin_*/unstripped/ && ln -s libiomp5.so.$(SONAME) libiomp5.so
	doxygen doc/doxygen/config
	cd doc/doxygen/generated/html/ && rm jquery.js && ln -s /usr/share/javascript/jquery/jquery.js

override_dh_clean:
	rm -rf tmp/
	dh_clean

override_dh_strip:
	dh_strip -plibiomp5 --dbg-package=libiomp5-dbg
