=== debian/watch ===
version=3
http://www.openmprtl.org/download .*/libomp_(.*)_oss.tgz
