=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # <copyright>
-#    Copyright (c) 2013 Intel Corporation.  All Rights Reserved.
+#    Copyright (c) 2013-2014 Intel Corporation.  All Rights Reserved.
 #
 #    Redistribution and use in source and binary forms, with or without
 #    modification, are permitted provided that the following conditions
