=== debian/changelog ===
openmprtl (0.20140926-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 07 Oct 2014 14:56:59 +0200
