=== debian/changelog ===
openmprtl (0.20150701-1) unstable; urgency=medium

  * New upstream release
  * Include the fix to build with gcc 5 (Closes: #778046)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 16 Jun 2015 18:11:19 +0200

openmprtl (0.20150401-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream release
  * New symbols (kmp_debugging, kmp_omp_debug_struct_info,
    kmpc_proxy_task_completed, kmpc_proxy_task_completed_ooo

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 27 Apr 2015 10:17:30 +0200

openmprtl (0.20141212-1~exp2) experimental; urgency=medium

  * Make the build reproducible (remove a date in the header +
    timestamp in the doc)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 31 Jan 2015 16:49:42 +0100

openmprtl (0.20141212-1~exp1) experimental; urgency=medium

  * New upstream release
  * Standards-Version updated to 3.9.6
  * 3 new symbols added (omp_is_initial_device*)
  * Patches refreshed

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 31 Dec 2014 13:13:25 +0100
